/*
THIS FILE IS A PART OF GTA V SCRIPT HOOK SDK
http://dev-c.com
(C) Alexander Blade 2015

Melee Riot mod by alphazolam
*/

/*
int parachuteIndex = PED::GET_PED_PARACHUTE_STATE(pedHandle)
parachuteIndex:
-1 = not parachuting
0 = skydiving with parachute
1 = pulling parachute
2 = parachuting
3 = falling after parachute ends


Ped Types:
Player = 1
Male = 4
Female = 5
Cop = 6
SWAT = 27
Animal = 28
Army = 29

potentially useful anims:
combat@drag_ped@ -> injured_pickup_side_right_plyr
combat@drag_ped@entry -> injured_pickup_90_plyr
move_action@p_m_one@unarmed@idle@variations -> idle_a

PED::SET_SCENARIO_PEDS_TO_BE_RETURNED_BY_NEXT_COMMAND()

*/

#include "script.h"

#include <string>
#include <ctime>
#include <vector>
#include <map>


std::vector <Ped> peds;
std::string statusText;
Player player;
Ped ped1;
Ped pedx;
Ped lastTarget;
Ped attacker;
Ped victim;
Ped tester;
Ped targetPed;
Ped chuteTarget;
Ped currentTarget;
Vector3 pedApos;
Vector3 pedBpos;
Vector3 position;
Vector3 targetPosition;
Vector3 playerPosition;
Vehicle veh;
Any gunhash;
Any weaponhash;
FILE * pFile;
int r;
int paraState = -1;
int copsVs = 1;
int pilotsNoLeaveVeh = 1;
int toughDrivers = 1;
int pedsTrip = 1;
int guns = 0;
int pedsLeaveVeh = 0;
int morePedsTargetPlayer = 0;
int driversTargetPlayer = 1;
int setPedAsCop = 0;
bool checkStage = false;
bool combatStage = false;
bool wasToggled = false;
bool wepOk = false;
bool remGuns = 0;
int noAnimals = 0;
bool ready = false;
int pedsIgnorePlayer = 0;
int oldStyle = 0;
int targetStacking = 0;
int regen = 0;
int sweat = 0;
int riotRadius = 0;
bool odds;
bool odds2;
int pedsParachute = 1;
int stunGun = 0;
int switchRate = 3;
int KEY = 0x6D;
int cfgFem = 5;
int cfgMen = 10;
int pedArmor = 100;
int pedMinHealth = 150;
int foundTarget;
int pedType;
int playerGroup;
int health;
int pool;
int maxHealth;
int processed = 0;
int pedsIgnoreAll = 1;
Hash friendly = 66666666;
Hash rioters = 55555555;
Hash rioters2 = 33333333;
Hash pairs = 22222222;
Hash* friendlyP = &friendly;
Hash* riotersP = &rioters;
Hash* pairsP = &friendly;
Hash* rioters2P = &rioters2;
float distance;
float distanceZ;
float playerDistance;

void set_status_text(std::string str)
{
	statusText = str;
}

void update_status_text()
{
	UI::SET_TEXT_FONT(0);
	UI::SET_TEXT_SCALE(0.55, 0.55);
	UI::SET_TEXT_COLOUR(255, 255, 255, 255);
	UI::SET_TEXT_WRAP(0.0, 1.0);
	UI::SET_TEXT_CENTRE(1);
	UI::SET_TEXT_DROPSHADOW(0, 0, 0, 0, 0);
	UI::SET_TEXT_EDGE(1, 0, 0, 0, 205);
	UI::_SET_TEXT_ENTRY("STRING");
	UI::_ADD_TEXT_COMPONENT_STRING((char *)statusText.c_str());
	UI::_DRAW_TEXT(0.5, 0.5);
}

bool mod_switch_pressed()
{
	return (GetAsyncKeyState(KEY) & 0x8000) != 0; //returns true if KEY is depressed
}

float distanceBetween(Ped pedA, Ped pedB)
{
	pedApos = ENTITY::GET_ENTITY_COORDS(pedA, true);
	pedBpos = ENTITY::GET_ENTITY_COORDS(pedB, true);
	return (GAMEPLAY::GET_DISTANCE_BETWEEN_COORDS(pedApos.x, pedApos.y, pedApos.z, pedBpos.x, pedBpos.y, pedBpos.z, true));
}

float verticalDistance(Ped pedA, Ped pedB)
{
	return abs(ENTITY::GET_ENTITY_HEIGHT_ABOVE_GROUND(pedA) - ENTITY::GET_ENTITY_HEIGHT_ABOVE_GROUND(pedB));
}

bool isPedBird(Ped ped) { return (!PED::IS_PED_HUMAN(ped) && ((ENTITY::GET_ENTITY_HEIGHT_ABOVE_GROUND(ped) > 0.2) && !PED::IS_PED_RAGDOLL(ped))); }

bool canAnimalAttack(Ped ped)
{	
	if (noAnimals == 1 || (!PED::IS_PED_HUMAN(ped) && distanceBetween(player, ped > 30)))
		return false;
	if ((noAnimals == 2) && (PED::IS_PED_MODEL(ped, GAMEPLAY::GET_HASH_KEY("A_C_Cow"))
		|| PED::IS_PED_MODEL(ped, GAMEPLAY::GET_HASH_KEY("A_C_Cow + Hi"))))
		return false;
	return !((PED::IS_PED_MODEL(ped, GAMEPLAY::GET_HASH_KEY("A_C_Seagull"))
		|| PED::IS_PED_MODEL(ped, GAMEPLAY::GET_HASH_KEY("A_C_Seagull + Hi"))
		|| PED::IS_PED_MODEL(ped, GAMEPLAY::GET_HASH_KEY("A_C_Cormorant + Hi"))
		|| PED::IS_PED_MODEL(ped, GAMEPLAY::GET_HASH_KEY("A_C_Cormorant"))
		|| PED::IS_PED_MODEL(ped, GAMEPLAY::GET_HASH_KEY("A_C_Pigeon"))
		|| PED::IS_PED_MODEL(ped, GAMEPLAY::GET_HASH_KEY("A_C_Pigeon + Hi"))
		|| PED::IS_PED_MODEL(ped, GAMEPLAY::GET_HASH_KEY("A_C_Chickenhawk + Hi"))
		|| PED::IS_PED_MODEL(ped, GAMEPLAY::GET_HASH_KEY("A_C_Chickenhawk"))
		|| PED::IS_PED_MODEL(ped, GAMEPLAY::GET_HASH_KEY("A_C_Crow"))
		|| PED::IS_PED_MODEL(ped, GAMEPLAY::GET_HASH_KEY("A_C_Crow + Hi"))
		|| PED::IS_PED_MODEL(ped, GAMEPLAY::GET_HASH_KEY("a_c_rabbit_01"))
		|| PED::IS_PED_MODEL(ped, GAMEPLAY::GET_HASH_KEY("a_c_cat_01"))
		|| PED::IS_PED_MODEL(ped, GAMEPLAY::GET_HASH_KEY("a_c_rat"))
		|| PED::IS_PED_MODEL(ped, GAMEPLAY::GET_HASH_KEY("a_c_rat + hi"))
		|| PED::IS_PED_MODEL(ped, GAMEPLAY::GET_HASH_KEY("A_C_Fish"))
		|| PED::IS_PED_MODEL(ped, GAMEPLAY::GET_HASH_KEY("A_C_Fish + Hi"))
		|| PED::IS_PED_MODEL(ped, GAMEPLAY::GET_HASH_KEY("A_C_Hen"))
		|| PED::IS_PED_MODEL(ped, GAMEPLAY::GET_HASH_KEY("A_C_Hen + Hi"))));
}

bool arePedsFighting(Ped pedA, Ped pedB)
{
	return ((PED::IS_PED_IN_COMBAT(pedA, pedB) && PED::IS_PED_IN_COMBAT(pedB, pedA))
		|| (PED::IS_PED_HEADTRACKING_PED(pedA, pedB) && ((PED::IS_PED_HEADTRACKING_PED(pedB, pedA)) || PED::IS_PED_FACING_PED(pedB, pedA, 0))));
}

void clearTasks(Ped ped)
{
	if (!AI::IS_PED_WALKING(ped) && (attacker != NULL || (!PED::IS_PED_IN_COMBAT(ped, true) && !PED::IS_PED_IN_MELEE_COMBAT(ped))
	|| (currentTarget != NULL && !arePedsFighting(ped, currentTarget))))
	{

		AI::CLEAR_PED_TASKS(ped);
		AI::CLEAR_PED_SECONDARY_TASK(ped);
		//PED::_0xA660FAF550EB37E5(ped, true); // clear look at?
		PED::RESET_PED_MOVEMENT_CLIPSET(ped, 0.0);
		DECISIONEVENT::ADD_SHOCKING_EVENT_FOR_ENTITY(81, ped, 180000.0);
		DECISIONEVENT::ADD_SHOCKING_EVENT_FOR_ENTITY(94, ped, 180000.0);
		DECISIONEVENT::ADD_SHOCKING_EVENT_FOR_ENTITY(98, ped, 180000.0);
		DECISIONEVENT::ADD_SHOCKING_EVENT_FOR_ENTITY(99, ped, 180000.0);
		DECISIONEVENT::ADD_SHOCKING_EVENT_FOR_ENTITY(0xFFFFFF, ped, 180000.0);
		AI::TASK_PAUSE(ped, -1);
		PED::SET_PED_KEEP_TASK(ped, 0);
	}
}

bool canPedRiotNoDistance(Ped ped)
{
	if (ped == NULL)
		return false;
	else
		return ((ped != player)
			&& (ENTITY::DOES_ENTITY_EXIST(ped))
			&& (!PED::_IS_PED_DEAD(ped, true))
			&& !isPedBird(ped)
			&& (PED::IS_PED_HUMAN(ped)) || canAnimalAttack(ped))
			&& (!PED::IS_PED_GROUP_MEMBER(ped, playerGroup));
}

bool canPedRiot(Ped ped)
{
	if (ped == NULL)
		return false;
	else if (riotRadius == 0)
		return canPedRiotNoDistance(ped);
	else
		return ((ped != player)
			&& (ENTITY::DOES_ENTITY_EXIST(ped))
			&& (distanceBetween(player, ped) < riotRadius)
			&& !isPedBird(ped)
			&& (!PED::_IS_PED_DEAD(ped, true))
			&& (PED::IS_PED_HUMAN(ped)) || canAnimalAttack(ped))
			&& (!PED::IS_PED_GROUP_MEMBER(ped, playerGroup));
}

bool isPedCop(Ped ped)
{
	pedType = PED::GET_PED_TYPE(ped);
	return ((pedType == 6) || (pedType == 27) || (pedType == 29));
}

bool doesPedHaveCommonGun(Ped ped)
{
	return (WEAPON::IS_PED_ARMED(ped, 0xFF)
	&& WEAPON::HAS_PED_GOT_WEAPON(ped, 0x1B06D571, true) //standard pistol
	|| WEAPON::HAS_PED_GOT_WEAPON(ped, 0x83BF0278, true) //M4
	|| WEAPON::HAS_PED_GOT_WEAPON(ped, 0x1D073A89, true) //shotgun
	|| WEAPON::HAS_PED_GOT_WEAPON(ped, 0x5EF9FEC4, true) //glock
	|| WEAPON::HAS_PED_GOT_WEAPON(ped, 0x9D07F764, true) //MG
	|| WEAPON::HAS_PED_GOT_WEAPON(ped, 0x13532244, true) //uzi
	|| WEAPON::HAS_PED_GOT_WEAPON(ped, 0x2BE6766B, true) //mp5
	|| WEAPON::HAS_PED_GOT_WEAPON(ped, 0xBFEFFF6D, true) //ak47
	|| WEAPON::HAS_PED_GOT_WEAPON(ped, GAMEPLAY::GET_HASH_KEY("WEAPON_SAWNOFFSHOTGUN"), true));
}

void removeWeapons(Ped ped)
{
	if (WEAPON::IS_PED_ARMED(ped, 0xFF))
	{
		WEAPON::REMOVE_WEAPON_FROM_PED(ped, 0x1B06D571); //beretta pistol
		WEAPON::REMOVE_WEAPON_FROM_PED(ped, 0x83BF0278); //M4 carbine
		WEAPON::REMOVE_WEAPON_FROM_PED(ped, 0x1D073A89); //pump shotgun 
		WEAPON::REMOVE_WEAPON_FROM_PED(ped, 0x5EF9FEC4); //glock
		WEAPON::REMOVE_WEAPON_FROM_PED(ped, 0x7FD62962); //combat MG
		//WEAPON::REMOVE_WEAPON_FROM_PED(ped, 0x22D8FE39); //ap pistol
		WEAPON::REMOVE_WEAPON_FROM_PED(ped, 0x99AEEB3B); //deagle
		WEAPON::REMOVE_WEAPON_FROM_PED(ped, 0x13532244); //micro smg
		WEAPON::REMOVE_WEAPON_FROM_PED(ped, 0x2BE6766B); //mp5
		WEAPON::REMOVE_WEAPON_FROM_PED(ped, 0x9D07F764); //MG
		WEAPON::REMOVE_WEAPON_FROM_PED(ped, 0x3656C8C1); //stun gun
		WEAPON::REMOVE_WEAPON_FROM_PED(ped, 0xE284C527); //assault shotgun
		WEAPON::REMOVE_WEAPON_FROM_PED(ped, 0x05FC3C11); //sniper
		WEAPON::REMOVE_WEAPON_FROM_PED(ped, 0x0C472FE2); //heavy sniper
		WEAPON::REMOVE_WEAPON_FROM_PED(ped, 0xEFE7E2DF); //assault smg
		WEAPON::REMOVE_WEAPON_FROM_PED(ped, 0xBFEFFF6D); //AK47
		WEAPON::REMOVE_WEAPON_FROM_PED(ped, 0xAF113F99); //advance rifle
		WEAPON::REMOVE_WEAPON_FROM_PED(ped, 0x9D61E50F); //bullpup shotgun
		WEAPON::REMOVE_WEAPON_FROM_PED(ped, 0x61012683); //tommygun
		WEAPON::REMOVE_WEAPON_FROM_PED(ped, 0xC0A3098D); //special carbine
		WEAPON::REMOVE_WEAPON_FROM_PED(ped, 0x7F229F94); //bullpup rifle
		WEAPON::REMOVE_WEAPON_FROM_PED(ped, 0x3AABBBAA); //heavy shotgun
		WEAPON::REMOVE_WEAPON_FROM_PED(ped, 0xC734385A); //marksman rifle
		WEAPON::REMOVE_WEAPON_FROM_PED(ped, 0xA89CB99E); //musket
		WEAPON::REMOVE_WEAPON_FROM_PED(ped, 0xD205520E); //heavy pistol
		WEAPON::REMOVE_WEAPON_FROM_PED(ped, 0xBFD21232); //SNS pistol
		WEAPON::REMOVE_WEAPON_FROM_PED(ped, 0x083839C4); //vintage pistol	
		if (isPedCop(ped))
			WEAPON::GIVE_DELAYED_WEAPON_TO_PED(ped, 0x678B81B1, 300, 1); //1737195953
	}
}

void simpleFight(Ped ped, Ped target)
{
	if ((ped != target) && !PED::IS_PED_IN_COMBAT(ped, target) && (!isPedBird(target) && !isPedBird(ped)))
	{
		if (PED::IS_PED_SITTING_IN_ANY_VEHICLE(ped))
			if (GAMEPLAY::GET_RANDOM_INT_IN_RANGE(1, (pedsLeaveVeh)) == 1)
				AI::TASK_PUT_PED_DIRECTLY_INTO_MELEE(ped, target, 0, 0, 0, 0);
			else
				AI::TASK_VEHICLE_CHASE(ped, target);
		else if (guns || doesPedHaveCommonGun(ped))
				AI::TASK_COMBAT_PED(ped, target, 0, 46);
		else
			AI::TASK_PUT_PED_DIRECTLY_INTO_MELEE(ped, target, 0, 0, 0, 0);

		lastTarget = target;
		PED::REGISTER_TARGET(ped, target);
		PED::SET_PED_KEEP_TASK(ped, 1);
	}
}

void ragdoll(Ped ped)
{
	if (PED::IS_PED_HUMAN(ped) && PED::IS_PED_ON_FOOT(ped))
	{
		PED::SET_PED_RAGDOLL_FORCE_FALL(ped);
		PED::SET_PED_TO_RAGDOLL(ped, 0, 0, 10, 0, 0, 0);
	}
}

void wakePed(Ped ped)
{
	PED::SET_BLOCKING_OF_NON_TEMPORARY_EVENTS(ped, false);
	position = ENTITY::GET_ENTITY_COORDS(ped, true);
	if (PED::IS_PED_HUMAN(ped))
	{
		if (stunGun == 0 || !FIRE::IS_ENTITY_ON_FIRE(ped))
			if (PED::IS_PED_FLEEING(ped))
			{
			if ((pedsTrip == 1) || GAMEPLAY::GET_RANDOM_INT_IN_RANGE(1, pedsTrip) == 1)
				ragdoll(ped);
			clearTasks(ped);
			}
	}
	if (!isPedCop(ped))
		PED::SET_BLOCKING_OF_NON_TEMPORARY_EVENTS(ped, true);
}

bool checkPlayer(Ped ped)
{
	if (pedsIgnorePlayer == 1)
	{
		if (PED::IS_PED_IN_COMBAT(ped, player) || (PED::IS_PED_HEADTRACKING_PED(ped, player) && PED::IS_PED_IN_MELEE_COMBAT(ped)))
		{
			PED::SET_PED_RELATIONSHIP_GROUP_HASH(ped, GAMEPLAY::GET_HASH_KEY("FRIENDLY"));
			clearTasks(ped);
			simpleFight(ped, lastTarget);
		}
	}
	else
	{
		distance = distanceBetween(ped, player);
		if ((PED::IS_PED_SITTING_IN_ANY_VEHICLE(ped) && PED::IS_PED_SITTING_IN_ANY_VEHICLE(player))
		&& (PLAYER::IS_PLAYER_PRESSING_HORN(player) || (distance < 20)) && GAMEPLAY::GET_RANDOM_INT_IN_RANGE(1, driversTargetPlayer) == 1)
			 return true;
		//else if (!PLAYER::IS_PLAYER_FREE_AIMING(player) && PED::IS_PED_ON_FOOT(player) && !PED::IS_PED_STOPPED(player)) //PLAYER::IS_PLAYER_PLAYING(player)) //&& 
		//{
		else if ((pedsIgnorePlayer < 1) && ((PED::IS_PED_IN_MELEE_COMBAT(player) || PED::IS_PED_IN_COMBAT(player, true))  //if player in combat
		&& (!PED::IS_PED_IN_COMBAT(ped, player) || PED::IS_PED_IN_COMBAT(player, ped)))) //and if ped not already fighting player or player already fighting said ped
			return true;
		else if ((morePedsTargetPlayer > 0) && (GAMEPLAY::GET_RANDOM_INT_IN_RANGE(1, morePedsTargetPlayer)) == 1)
			return true;
		//}
	}
	return false;
}

Ped findCurrentTargetOf(Ped ped)
{
	pedx = NULL;
	//if (PED::IS_PED_IN_COMBAT(ped, true) && !PED::IS_PED_IN_MELEE_COMBAT(ped))
	//{
	//	if (PED::IS_PED_HEADTRACKING_PED(ped, player))
	//		return player;
	//	else
	//	for (int c = 0; c < peds.size(); c++)
	//		if ((peds.at(c) != ped) && canPedRiot(peds.at(c)))
	//			if (PED::IS_PED_IN_COMBAT(ped, peds.at(c)))
	//				if (PED::IS_PED_IN_COMBAT(peds.at(c), ped))
	//					return peds.at(c);
	//				else if (PED::IS_PED_HEADTRACKING_PED(ped, peds.at(c)))
	//					pedx = peds.at(c);
	//}
	//else 
	if (PED::IS_PED_IN_COMBAT(ped, true) || PED::IS_PED_IN_MELEE_COMBAT(ped))
	{
		if (PED::IS_PED_HEADTRACKING_PED(ped, player))
			return player;
		else
		for (int c = 0; c < peds.size(); c++)
			if ((peds.at(c) != ped) && canPedRiot(peds.at(c)))
				if (PED::IS_PED_FACING_PED(ped, peds.at(c), 0))
					if (PED::IS_PED_HEADTRACKING_PED(ped, peds.at(c)))
							return peds.at(c);
					else
						pedx = peds.at(c);
	}
	return pedx;
}

Ped findAttacker(Ped ped)
{
	attacker = NULL;
	if (ENTITY::HAS_ENTITY_BEEN_DAMAGED_BY_ANY_VEHICLE(ped))
	{
		for (int d = 0; d < peds.size(); d++)
			if (canPedRiot(peds.at(d)) && PED::IS_PED_SITTING_IN_ANY_VEHICLE(peds.at(d)))
				if (ENTITY::HAS_ENTITY_BEEN_DAMAGED_BY_ENTITY(ped, PED::GET_VEHICLE_PED_IS_USING(peds.at(d)), 1))
				{
			attacker = peds.at(d);//VEHICLE::GET_PED_IN_VEHICLE_SEAT(vehicles.at(d), 0);
			if (attacker != NULL)
				return attacker;
				}
	}
	if ((attacker == NULL) && ENTITY::HAS_ENTITY_BEEN_DAMAGED_BY_ANY_PED(ped))
	{
		for (int c = 0; c < peds.size(); c++)
			if ((peds.at(c) != player) && (peds.at(c) != ped) && (ENTITY::HAS_ENTITY_BEEN_DAMAGED_BY_ENTITY(ped, peds.at(c), 1)))
			{
			attacker = peds.at(c);
			if (PED::IS_PED_HEADTRACKING_PED(attacker, ped) || PED::IS_PED_FACING_PED(attacker, ped, 0) || (!odds && !PED::IS_PED_HUMAN(peds.at(c))))
				return attacker;
			}
	}
	return attacker;
}

Ped findVictim(Ped ped)
{
	victim = NULL;
	for (int c = 0; c < peds.size(); c++)
		if ((peds.at(c) != player) && (peds.at(c) != ped) && ENTITY::HAS_ENTITY_BEEN_DAMAGED_BY_ENTITY(peds.at(c), ped, 1))
		{
		victim = peds.at(c);
		if (PED::IS_PED_HEADTRACKING_PED(ped, victim) || PED::IS_PED_FACING_PED(ped, victim, 0))
			return victim;
		}
	return victim;
}

void dehumanizePed(Ped ped)
{

	if (isPedBird(ped))
		PED::REMOVE_PED_ELEGANTLY(&ped);
	else
	{
		PED::SET_PED_FLEE_ATTRIBUTES(ped, 0, 0);
		PED::SET_PED_COMBAT_ATTRIBUTES(ped, 46, TRUE);
		if (!ENTITY::HAS_ENTITY_BEEN_DAMAGED_BY_ANY_PED(ped) && !ENTITY::HAS_ENTITY_BEEN_DAMAGED_BY_ANY_VEHICLE(ped))
		{
			if ((maxHealth < pedMinHealth) && ((PED::GET_PED_MAX_HEALTH(ped1) != 1297) && (PED::GET_PED_MAX_HEALTH(ped1) != 404)))
			{
				PED::SET_PED_MAX_HEALTH(ped, pedMinHealth);
				ENTITY::SET_ENTITY_HEALTH(ped, pedMinHealth);
			}
			if (PED::GET_PED_ARMOUR(ped) < pedArmor)
			{
				PED::ADD_ARMOUR_TO_PED(ped, pedArmor);
				PED::SET_PED_ARMOUR(ped, pedArmor);
			}
			if (PED::GET_PED_MONEY(ped) < 10)
				PED::SET_PED_MONEY(ped, 0);
		}
		if (PED::IS_PED_SITTING_IN_ANY_VEHICLE(ped))
		{
			if (guns)
				WEAPON::GIVE_DELAYED_WEAPON_TO_PED(ped, 0x22D8FE39, 300, 1); //pistol: 0x22D8FE39 //ap-pistol: 0x1B06D571
			veh = PED::GET_VEHICLE_PED_IS_USING(ped);
			if (toughDrivers != 0)
			{
				VEHICLE::SET_VEHICLE_IS_WANTED(veh, true);
				VEHICLE::SET_VEHICLE_HAS_STRONG_AXLES(veh, true);
				PED::SET_DRIVER_ABILITY(ped, 1.0);
				PED::SET_DRIVER_AGGRESSIVENESS(ped, 10);
				AI::SET_DRIVE_TASK_CRUISE_SPEED(ped, 200);
				VEHICLE::SET_VEHICLE_EXPLODES_ON_HIGH_EXPLOSION_DAMAGE(veh, false);
				VEHICLE::SET_VEHICLE_STRONG(veh, true);
				PED::SET_PED_STEERS_AROUND_PEDS(ped, false);
			}
		}
		if (!PED::IS_PED_HUMAN(ped))//{
			PED::SET_PED_RELATIONSHIP_GROUP_HASH(ped, GAMEPLAY::GET_HASH_KEY("RIOTERS"));
		else if ((guns) || PED::IS_PED_SHOOTING(ped))
		{
			PED::SET_PED_SEEING_RANGE(ped, 20);
			PED::SET_PED_HEARING_RANGE(ped, 20);
			PED::SET_PED_CAN_COWER_IN_COVER(ped, true);
			PED::SET_PED_CAN_PEEK_IN_COVER(ped, true);
			PED::SET_PED_CAN_SWITCH_WEAPON(ped, false);
			PED::SET_PED_COMBAT_RANGE(ped, 20);
			PED::SET_PED_ACCURACY(ped, 1);
			PED::SET_PED_RELATIONSHIP_GROUP_HASH(ped, GAMEPLAY::GET_HASH_KEY("RIOTERS"));
		}
		else
		{
			PED::SET_PED_COMBAT_RANGE(ped, 10);
			PED::SET_PED_SEEING_RANGE(ped, 10);
			PED::SET_PED_HEARING_RANGE(ped, 10);
		}
		if (copsVs == 1)
			if (isPedCop(ped) || morePedsTargetPlayer > 0)
				PED::SET_PED_RELATIONSHIP_GROUP_HASH(ped, GAMEPLAY::GET_HASH_KEY("COUGAR"));
			else if (!isPedCop(ped) && morePedsTargetPlayer > 0)
				PED::SET_PED_RELATIONSHIP_GROUP_HASH(ped, GAMEPLAY::GET_HASH_KEY("RIOTERS"));
		PED::SET_PED_NEVER_LEAVES_GROUP(ped, false);
		PED::REMOVE_PED_FROM_GROUP(ped);
		AI::SET_PED_PATH_AVOID_FIRE(ped, true);
		AI::SET_PED_PATH_CAN_USE_CLIMBOVERS(ped, true);
		AI::SET_PED_PATH_CAN_USE_LADDERS(ped, true);
		AI::SET_PED_PATH_CAN_DROP_FROM_HEIGHT(ped, true);
		PED::SET_CAN_ATTACK_FRIENDLY(ped, 1, 1);
		PED::SET_PED_COMBAT_ABILITY(ped, 2);
		PED::SET_PED_CAN_BE_TARGETTED(ped, true);
		PED::SET_PED_CAN_BE_TARGETED_WITHOUT_LOS(ped, false);
	}
}

bool isPedIdle(Ped ped)
{
	return ((PED::IS_PED_STOPPED(ped)
		|| !PED::IS_PED_IN_MELEE_COMBAT(ped)
		|| PED::IS_PED_FLEEING(ped)
		|| PED::IS_PED_SITTING_IN_ANY_VEHICLE(ped)
		|| AI::IS_PED_WALKING(ped))
		|| PED::IS_PED_IN_COMBAT(ped, player)
		&& (!AI::IS_PED_RUNNING(ped)
		&& !FIRE::IS_ENTITY_ON_FIRE(ped)
		&& PED::IS_PED_HUMAN(ped)));
}

bool isPedInStoppedCar(Ped ped)
{
	return PED::IS_PED_IN_ANY_VEHICLE(ped, true) && VEHICLE::IS_VEHICLE_STOPPED(PED::GET_VEHICLE_PED_IS_USING(ped));
}

bool isPedWaitingForTurn(Ped ped)
{
	if (guns)
		return (PED::IS_PED_IN_COMBAT(ped, true) && !arePedsFighting(ped, findCurrentTargetOf(ped)));
	else
		return (PED::IS_PED_IN_MELEE_COMBAT(ped) && !arePedsFighting(ped, findCurrentTargetOf(ped)));
}

Ped findRandomTarget(Ped ped)
{
	pool = int(peds.size());
	pedx = peds.at(GAMEPLAY::GET_RANDOM_INT_IN_RANGE(0, pool));
	for (int i = 0; i < 4; i++)
		if ((pedx != ped) && canPedRiot(pedx) && verticalDistance(ped, pedx) < 7.5)
			if ((targetStacking == 1) || (lastTarget != pedx))
				return pedx;
			else
				pedx = peds.at(GAMEPLAY::GET_RANDOM_INT_IN_RANGE(0, pool));
	return pedx;
}

void flameStun(Ped ped)
{
	if (PED::IS_PED_BEING_STUNNED(ped, -1))
		if (PED::GET_PED_MAX_HEALTH(ped) != 404)
		{
		PED::SET_PED_MAX_HEALTH(ped, 404);
		PED::ADD_ARMOUR_TO_PED(ped, 100);
		FIRE::START_ENTITY_FIRE(ped);
		PED::SET_PED_CAN_RAGDOLL(ped, false);
		ENTITY::SET_ENTITY_CAN_BE_DAMAGED(ped, false);
		ENTITY::SET_ENTITY_RENDER_SCORCHED(ped, true);
		}
		else if (PED::GET_PED_MAX_HEALTH(ped) == 404)
		{
			if ((guns == 1) && !WEAPON::IS_PED_ARMED(ped, 0xFF)) //only happens when writhing injured on the floor
			{
				ENTITY::SET_ENTITY_CAN_BE_DAMAGED(ped, true);
				PED::SET_PED_CAN_RAGDOLL(ped, true);
				PED::EXPLODE_PED_HEAD(ped, 2339582971); //bleeding damage
				if (FIRE::IS_ENTITY_ON_FIRE(ped))
					PED::EXPLODE_PED_HEAD(ped, 2339582971); //fire damage
			}
			else if (!FIRE::IS_ENTITY_ON_FIRE(ped) || PED::_IS_PED_DEAD(ped, true))
			{
				ENTITY::SET_ENTITY_CAN_BE_DAMAGED(ped, true);
				PED::SET_PED_CAN_RAGDOLL(ped, true);
				PED::SET_PED_MAX_HEALTH(ped, ENTITY::GET_ENTITY_HEALTH(ped));
			}
			else if (!odds && !odds2)
				if (GAMEPLAY::GET_RANDOM_INT_IN_RANGE(1, 4) == 1)
					AI::TASK_REACT_AND_FLEE_PED(ped, player);
				else
					simpleFight(ped, findRandomTarget(ped));
		}
}

Ped findClosestIdleTarget(Ped ped)
{
	pool = int(peds.size());
	r = GAMEPLAY::GET_RANDOM_INT_IN_RANGE(0, pool);
	pedx = peds.at(r);
	tester = peds.at(r);


	for (int c = 0; c < peds.size(); c++)
		if ((peds.at(c) != ped) && (lastTarget != peds.at(c)) && canPedRiot(peds.at(c)) && isPedIdle(peds.at(c)))
			if (!ENTITY::HAS_ENTITY_BEEN_DAMAGED_BY_ANY_PED(peds.at(c)) || isPedInStoppedCar(peds.at(c)))
			{
		distance = distanceBetween(ped, peds.at(c));
		if ((distance < 50) && isPedWaitingForTurn(peds.at(c)))
				return peds.at(c);
		else if (distance < (distanceBetween(ped, pedx)))
				pedx = peds.at(c);
			}

	if ((pedx == tester) && (distanceBetween(player, tester) > 70 || !isPedIdle(tester)))
		return findRandomTarget(ped);
	else
		return pedx;
}

Ped findClosestHumanTarget(Ped ped)
{

	pool = int(peds.size());
	r = GAMEPLAY::GET_RANDOM_INT_IN_RANGE(0, pool);
	pedx = peds.at(r);
	tester = peds.at(r);

	for (int c = 0; c < peds.size(); c++)
		if ((peds.at(c) != ped) && canPedRiot(peds.at(c)) && PED::IS_PED_HUMAN(peds.at(c)))
			if ((distanceBetween(ped, peds.at(c)) < (distanceBetween(ped, targetPed))))
				targetPed = peds.at(c);

	if (tester == targetPed)
		return lastTarget;
	return pedx;
}

void parachute(Ped ped)
{
	float height = ENTITY::GET_ENTITY_HEIGHT_ABOVE_GROUND(ped);
	if ((pedsParachute > 0) && (ENTITY::GET_ENTITY_HEIGHT_ABOVE_GROUND(ped) > 2)) //&& (ENTITY::IS_ENTITY_IN_AIR(ped) && !PED::IS_PED_ON_FOOT(ped)))
	{
		paraState = PED::GET_PED_PARACHUTE_STATE(ped);
		if (((paraState == -1) && height > 3.5) || (GAMEPLAY::GET_RANDOM_INT_IN_RANGE(0, 1) == 1))
			ENTITY::SET_ENTITY_RECORDS_COLLISIONS(ped, true); //fall damage
		if ((PED::GET_PED_MAX_HEALTH(ped) != 1297) && ((pedsParachute == 1) && height > 10) || ((pedsParachute > 1) && height > pedsParachute))
		{
			if (!PED::IS_PED_ON_FOOT(ped) || PED::IS_PED_FALLING(ped))
			{
				PED::SET_PED_CAN_RAGDOLL(ped, true);
				PED::SET_PED_KEEP_TASK(ped, 1);
				
				if ((PED::IS_PED_IN_COMBAT(ped, player) || (PED::IS_PED_IN_COMBAT(player, ped)))
				|| (ENTITY::HAS_ENTITY_BEEN_DAMAGED_BY_ENTITY(ped, player, 1) || ENTITY::HAS_ENTITY_BEEN_DAMAGED_BY_ENTITY(player, ped, 1)))
				{
					distance = GAMEPLAY::GET_RANDOM_FLOAT_IN_RANGE(-5.0, 5.0);
					distanceZ = ENTITY::GET_ENTITY_HEIGHT_ABOVE_GROUND(player);
					chuteTarget = player;
				}
				else if ((currentTarget != NULL) && ((canPedRiot(currentTarget) || (currentTarget == player))))
				{
					distance = GAMEPLAY::GET_RANDOM_FLOAT_IN_RANGE(-5.0, 5.0);
					distanceZ = ENTITY::GET_ENTITY_HEIGHT_ABOVE_GROUND(currentTarget);
					chuteTarget = currentTarget;
				}
				else if (!canPedRiot(targetPed) || (GAMEPLAY::GET_RANDOM_INT_IN_RANGE(0, 2) == 1))
				{
					distance = GAMEPLAY::GET_RANDOM_FLOAT_IN_RANGE(-75.0, 75.0);
					distanceZ = height;
					chuteTarget = ped;
				}
				else
				{
					distance = GAMEPLAY::GET_RANDOM_FLOAT_IN_RANGE(-5.0, 5.0);
					distanceZ = ENTITY::GET_ENTITY_HEIGHT_ABOVE_GROUND(targetPed);
					chuteTarget = targetPed; //same as "lastTarget"; always changing
				}
				targetPosition = ENTITY::GET_OFFSET_FROM_ENTITY_IN_WORLD_COORDS(chuteTarget, 0.0, 0.0, 1.1);
				if ((paraState != 2 && paraState != 1))
				{
					WEAPON::GIVE_DELAYED_WEAPON_TO_PED(ped, GAMEPLAY::GET_HASH_KEY("GADGET_PARACHUTE"), 300, 1);
					PED::SET_PED_MAX_HEALTH(ped, 1297);
					if (distanceZ < 1.1)
						AI::TASK_PARACHUTE_TO_TARGET(ped, targetPosition.x + distance, targetPosition.y + distance, ((targetPosition.z - distanceZ) - abs(distance)));
					else
						AI::TASK_PARACHUTE_TO_TARGET(ped, targetPosition.x + distance, targetPosition.y + distance, ((targetPosition.z - distanceZ) - 10.0));
					PED::REGISTER_TARGET(ped, chuteTarget);
					ENTITY::SET_ENTITY_RECORDS_COLLISIONS(ped, false);
				}
				else
					AI::SET_PARACHUTE_TASK_TARGET(ped, targetPosition.x + distance, targetPosition.y + distance, targetPosition.z - abs(distance));
			}//end main parachute commands
		}
	}
}


Ped findIdleOpponent(Ped ped)
{
	//THIS IS THE MAIN TARGETING SYSTEM AS OF VERSION 0.9a
	pool = int(peds.size());
	r = GAMEPLAY::GET_RANDOM_INT_IN_RANGE(0, pool);
	pedx = peds.at(r);
	tester = peds.at(r);
	for (int c = 0; c < peds.size(); c++)
		if ((peds.at(c) != ped) && lastTarget != peds.at(c) && canPedRiot(peds.at(c)) && isPedIdle(peds.at(c)))
			if ((distanceBetween(player, peds.at(c)) < 100) && isPedWaitingForTurn(peds.at(c)))
				return peds.at(c);
			else if (isPedInStoppedCar(peds.at(c)) || !ENTITY::HAS_ENTITY_BEEN_DAMAGED_BY_ANY_PED(peds.at(c)))
				pedx = peds.at(c);

	if ((pedx == tester) && !isPedIdle(tester))
		return findClosestIdleTarget(ped);
	else
		return pedx;
}

Ped findClosestCop(Ped ped)
{
	pool = int(peds.size());
	r = GAMEPLAY::GET_RANDOM_INT_IN_RANGE(0, pool);
	pedx = peds.at(r);
	tester = peds.at(r);

	for (int c = 0; c < peds.size(); c++)
		if ((peds.at(c) != ped) && (isPedCop(peds.at(c))))
			if (distanceBetween(ped, peds.at(c)) < (distanceBetween(ped, peds.at(c))))
				if (lastTarget != peds.at(c))
					return peds.at(c);
				else
					pedx = peds.at(c);

	if (pedx == tester)
		return findIdleOpponent(ped);
	else return pedx;
}

void makeFight(Ped ped, Ped target)
{
	if (canPedRiot(ped))// && !isPedCop(ped))
	{
		double distance = distanceBetween(ped, target);

		if (distance < 0.1 || (FIRE::IS_ENTITY_ON_FIRE(target)))
			target = findRandomTarget(ped);
		else if (lastTarget == target)
		{
			target = findIdleOpponent(ped);
			if (lastTarget == target)
				target = findRandomTarget(ped);
		}

		if (distanceBetween(player, target) > 50)
		target = findClosestIdleTarget(ped);

		simpleFight(ped, target);
		lastTarget = target;

		if (!guns && (target != player) && (!PED::IS_PED_HUMAN(target) || isPedIdle(target) || isPedWaitingForTurn(target)))
			simpleFight(target, ped);
	}
}

void fight(Ped ped, Ped target)
{
	//if (!odds && AI::IS_PED_GETTING_UP(ped))
	//{
	//	clearTasks(ped);
	//	simpleFight(ped, findAttacker(ped));
	//}
	//else
	if (guns || WEAPON::IS_PED_ARMED(ped, 0xFF))
		simpleFight(ped, target);
	else
		makeFight(ped, target);
}

void registerLastTarget(Ped ped)
{
	currentTarget = findCurrentTargetOf(ped);
	if (currentTarget != NULL)
	{
		lastTarget = currentTarget;
		PED::REGISTER_TARGET(ped, lastTarget);
		PED::SET_PED_KEEP_TASK(ped, 1);
	}
}


void setRelationships()
{

	PED::SET_RELATIONSHIP_BETWEEN_GROUPS(1, GAMEPLAY::GET_HASH_KEY("FRIENDLY"), GAMEPLAY::GET_HASH_KEY("PLAYER"));
	PED::SET_RELATIONSHIP_BETWEEN_GROUPS(3, GAMEPLAY::GET_HASH_KEY("PLAYER"), GAMEPLAY::GET_HASH_KEY("FRIENDLY"));
	PED::SET_RELATIONSHIP_BETWEEN_GROUPS(3, GAMEPLAY::GET_HASH_KEY("PLAYER"), GAMEPLAY::GET_HASH_KEY("RIOTERS"));
	PED::SET_RELATIONSHIP_BETWEEN_GROUPS(3, GAMEPLAY::GET_HASH_KEY("RIOTERS"), GAMEPLAY::GET_HASH_KEY("PLAYER"));
	PED::SET_RELATIONSHIP_BETWEEN_GROUPS(2, GAMEPLAY::GET_HASH_KEY("CIVMALE"), GAMEPLAY::GET_HASH_KEY("RIOTERS"));
	PED::SET_RELATIONSHIP_BETWEEN_GROUPS(2, GAMEPLAY::GET_HASH_KEY("CIVFEMALE"), GAMEPLAY::GET_HASH_KEY("RIOTERS"));
	PED::SET_RELATIONSHIP_BETWEEN_GROUPS(5, GAMEPLAY::GET_HASH_KEY("RIOTERS"), GAMEPLAY::GET_HASH_KEY("RIOTERS"));
	PED::SET_RELATIONSHIP_BETWEEN_GROUPS(5, GAMEPLAY::GET_HASH_KEY("FRIENDLY"), GAMEPLAY::GET_HASH_KEY("PLAYER"));
	PED::SET_RELATIONSHIP_BETWEEN_GROUPS(5, GAMEPLAY::GET_HASH_KEY("RIOTERS"), GAMEPLAY::GET_HASH_KEY("FRIENDLY"));

}

void main()
{
	int tic = 0;
	int tic2 = 0;
	int tic3 = 0;
	bool active = false;
	const int melee = 16;
	const int firearms = 50;
	char *weapons[melee] = {"WEAPON_DAGGER", "WEAPON_KNIFE", "WEAPON_BAT", "WEAPON_CROWBAR", "WEAPON_CROWBAR", "WEAPON_GOLFCLUB", "WEAPON_HAMMER",
		"WEAPON_HAMMER", "WEAPON_HATCHET", "WEAPON_NIGHTSTICK", "WEAPON_KNIFE", "WEAPON_BOTTLE", "WEAPON_BAT", "WEAPON_BOTTLE", "WEAPON_GOLFCLUB", "WEAPON_HATCHET"};
	char *weapons2[firearms] = {"WEAPON_MINIGUN", "WEAPON_PISTOL", "WEAPON_COMBATPISTOL", "WEAPON_APPISTOL", "WEAPON_PISTOL50", "WEAPON_MG", "WEAPON_COMBATMG",
		"WEAPON_MICROSMG", "WEAPON_SMG", "WEAPON_ASSAULTSMG", "WEAPON_ASSAULTRIFLE", "WEAPON_CARBINERIFLE", "WEAPON_ADVANCEDRIFLE",
		"WEAPON_PUMPSHOTGUN", "WEAPON_SAWNOFFSHOTGUN", "WEAPON_ASSAULTSHOTGUN", "WEAPON_BULLPUPSHOTGUN", "WEAPON_SNIPERRIFLE",
		"WEAPON_MUSKET", "WEAPON_SPECIALCARBINE", "WEAPON_HEAVYPISTOL", "WEAPON_PISTOL",
		"WEAPON_COMBATPISTOL", "WEAPON_APPISTOL", "WEAPON_PISTOL50", "WEAPON_MICROSMG", "WEAPON_MG", "WEAPON_COMBATMG", "WEAPON_PUMPSHOTGUN",
		"WEAPON_SAWNOFFSHOTGUN", "WEAPON_ASSAULTSHOTGUN", "WEAPON_BULLPUPSHOTGUN", "WEAPON_SNIPERRIFLE",
		"WEAPON_PISTOL", "WEAPON_SPECIALCARBINE", "WEAPON_HEAVYPISTOL", "WEAPON_DAGGER", "WEAPON_KNIFE", "WEAPON_BAT", "WEAPON_CROWBAR", "WEAPON_CROWBAR", "WEAPON_GOLFCLUB", "WEAPON_HAMMER",
		"WEAPON_HAMMER", "WEAPON_HATCHET", "WEAPON_BOTTLE", "WEAPON_BOTTLE", "WEAPON_BAT", "WEAPON_FLAREGUN", "WEAPON_HEAVYPISTOL"};

	setRelationships();

	//begin an infinite while loop:
	while (true)
	{
		if (tic3 == 0)
		{
			pFile = fopen("meleeriot.ini", "r");

			if (pFile)
			{
				fscanf(pFile, "MELEE RIOT AMBIENT PEDS RIOT BY ALPHAZOLAM Hotkey = [%x]", &KEY);
				fscanf(pFile, " Guns = [%d]", &guns);
				fscanf(pFile, " Parachutes = [%d]", &pedsParachute);
				fscanf(pFile, " Peds sweat = [%d]", &sweat);
				fscanf(pFile, " No animals = [%d]", &noAnimals);
				fscanf(pFile, " Target-stacking = [%d]", &targetStacking);
				fscanf(pFile, " Tougher ped cars = [%d]", &toughDrivers);
				fscanf(pFile, " Peds ignore player = [%d]", &pedsIgnorePlayer);
				fscanf(pFile, " Ped minimum armor = [%d]", &pedArmor);
				fscanf(pFile, " Ped minimum health = [%d]", &pedMinHealth);
				fscanf(pFile, " Remove common/cop guns = [%d]", &remGuns);
				fscanf(pFile, " Old (random) targeting = [%d]", &oldStyle);
				fscanf(pFile, " Riot radius around player = [%d]", &riotRadius);
				fscanf(pFile, " Peds regen health outside of combat = [%d]", &regen);
				fscanf(pFile, " Riot activity rate = 1/[%d]", &pedsIgnoreAll);
				fscanf(pFile, " Target-switching odds = 1/[%d]", &switchRate);
				fscanf(pFile, " Male melee weapon odds = 1/[%d]", &cfgMen);
				fscanf(pFile, " Female melee weapon odds = 1/[%d]", &cfgFem);
				fscanf(pFile, " Peds trip when fleeing odds = 1/[%d]", &pedsTrip);
				fscanf(pFile, " More peds target player odds = 1/[%d]", &morePedsTargetPlayer);
				fscanf(pFile, " More drivers chase player odds = 1/[%d]", &driversTargetPlayer);
				fscanf(pFile, " Peds leave vehicles faster odds = 1/[%d]", &pedsLeaveVeh);
				fscanf(pFile, " Pilots do not bail out = [%d]", &pilotsNoLeaveVeh);
				fscanf(pFile, " Cops vs SWAT vs Army = [%d]", &copsVs);
				fscanf(pFile, " Flaming stun gun (extinguish ped to restore) = [%d]", &stunGun);
				fscanf(pFile, " Set player as cop (change playermodel to restore) = [%d]", &setPedAsCop);
				fscanf(pFile, " Custom 'guns' weapons list: (50 weapons max, 5 per line){%s}", &weapons2[firearms]);
				fscanf(pFile, " Custom melee weapons list: (16 weapons max, 4 per line){%s}", &weapons[melee]);
				fclose(pFile);
			}
		}
		//-----------------------------------
		//Purge peds:


		for (int i = 0; i < peds.size(); i++)
		{
			if (!ENTITY::DOES_ENTITY_EXIST(peds.at(i)))
			{
				peds.erase(peds.begin() + i);
				break;
			}
			else if (canPedRiotNoDistance(peds.at(i)))
			{
				ENTITY::SET_PED_AS_NO_LONGER_NEEDED(&peds.at(i));
				peds.erase(peds.begin() + i);
				//break;
			}
			else if (distanceBetween(player, peds.at(i)) > 600)
			{
				ENTITY::SET_ENTITY_AS_NO_LONGER_NEEDED(&peds.at(i));
				peds.erase(peds.begin() + i);
				break;
			}
			else if (PED::_IS_PED_DEAD(peds.at(i), true))
			{
				peds.erase(peds.begin() + i);
				break;
			}
			else
			{
				ENTITY::SET_ENTITY_AS_NO_LONGER_NEEDED(&peds.at(i));
				peds.erase(peds.begin() + i);
			}
		}

		if (mod_switch_pressed())
		{
			if (active == false)
			{
				set_status_text("Enabling Melee Riot"); update_status_text();
			}
			else
			{
				set_status_text("Disabling Melee Riot"); update_status_text();
			}
			wasToggled = true;
		}
		else if (wasToggled == true)
		{
			wasToggled = false;
			active = !active;
			if (setPedAsCop == 1)
			{
				PED::SET_PED_AS_COP(player, 0);
				PED::SET_CAN_ATTACK_FRIENDLY(player, 0, 0);
			}
		}
		if (tic3 >= 150)
			tic3 = 0;
		else
			tic3++;

		if (peds.size() == 0)
			ready = true;

		if (active) //mod
		{

			tic++;
			tic2++;

			if (tic >= 90) { combatStage = true; tic = 0; }

			if (tic2 >= 30) { checkStage = true; tic2 = 0; }

			if ((combatStage || checkStage))
			{
				if (setPedAsCop == 1)
				{
					PED::SET_PED_AS_COP(player, true);
					PED::SET_CAN_ATTACK_FRIENDLY(player, 1, 1);
				}
				player = PLAYER::PLAYER_PED_ID();
				playerGroup = PLAYER::GET_PLAYER_GROUP(player);
				playerPosition = CAM::_GET_GAMEPLAY_CAM_COORDS();//ENTITY::GET_ENTITY_COORDS(player, true);
				const int numElements = 201;
				const int arrSize = (numElements + 1) * 2;
				Ped nearbyPeds[arrSize];
				nearbyPeds[0] = numElements;
				int numRioters = PED::GET_PED_NEARBY_PEDS(player, nearbyPeds, -1);

				if (nearbyPeds != NULL)
				{
					for (int i = 0; i < numRioters; i++)
					{
						odds = ((numRioters % 4) != 0);
						odds2 = (GAMEPLAY::GET_RANDOM_INT_IN_RANGE(1, 5) != 1);

						int offsettedID = i * 2 + 2;
						ped1 = nearbyPeds[offsettedID];

						if (canPedRiot(ped1))
						{
							currentTarget = findCurrentTargetOf(ped1);
							if (currentTarget != NULL)
								targetPosition = ENTITY::GET_ENTITY_COORDS(currentTarget, true);
							else
							{
								targetPosition = ENTITY::GET_ENTITY_COORDS(lastTarget, true);
								if ((pedsParachute > 0) && PED::GET_PED_PARACHUTE_STATE(currentTarget) != -1)
								{
									peds.push_back(ped1); 
									continue;
								}
							}
							wakePed(ped1);
							if (pedsParachute > 0)
								parachute(ped1);
							if (!ENTITY::HAS_ENTITY_BEEN_DAMAGED_BY_ANY_PED(ped1))
								dehumanizePed(ped1);
							else if (processed > 4)
							{
								processed = 0;
								dehumanizePed(ped1);
							}
							else
								processed++;

							if (combatStage && (peds.size() > 1) && ((pedsParachute < 1) || PED::GET_PED_PARACHUTE_STATE(ped1) == -1)) //combat commands are given here
							//PED::GET_PED_PARACHUTE_STATE(ped1) != 2) 
							{

								if (targetStacking == 1)
								{ //disregard lasttarget for the next ped
									targetPed = lastTarget;
									lastTarget = NULL;
								}
								if ((regen == 1) && (numRioters % 5 == 0))
								{
									if ((!PED::IS_PED_IN_COMBAT(ped1, true) && !PED::IS_PED_IN_MELEE_COMBAT(ped1))
									&& ((PED::GET_PED_MAX_HEALTH(ped1) != 1297) && (PED::GET_PED_MAX_HEALTH(ped1) != 404)))
										ENTITY::SET_ENTITY_HEALTH(ped1, PED::GET_PED_MAX_HEALTH(ped1));
								}

								if ((pedsParachute != 0) && (PED::GET_PED_MAX_HEALTH(ped1) == 1297))
								{

									if (chuteTarget != NULL && (canPedRiot(chuteTarget) || (chuteTarget == player)))
									{
										fight(ped1, chuteTarget);
										if (chuteTarget != player && isPedIdle(chuteTarget) || isPedWaitingForTurn(chuteTarget))
											fight(chuteTarget, ped1);
									}
									else
									{
										if (ENTITY::HAS_ENTITY_BEEN_DAMAGED_BY_ENTITY(ped1, player, true))
											simpleFight(ped1, player);
										else
											fight(ped1, findClosestHumanTarget(ped1));
									}
									if (PED::IS_PED_MALE(ped1))
										PED::SET_PED_MAX_HEALTH(ped1, 200);
									else PED::SET_PED_MAX_HEALTH(ped1, 150);

								}
								else if (findAttacker(ped1) != NULL)
								{
									if (sweat != 0)
									{
										if (sweat == 2 && !PED::IS_PED_MALE(ped1))
										{
											PED::SET_PED_WETNESS_ENABLED_THIS_FRAME(ped1);
											PED::SET_PED_WETNESS_HEIGHT(ped1, 100.0);
										}
										else if (sweat == 1)
										{
											PED::SET_PED_WETNESS_ENABLED_THIS_FRAME(ped1);
											PED::SET_PED_WETNESS_HEIGHT(ped1, 100.0);
										}
									}
									if ((arePedsFighting(ped1, attacker))
									&& (PED::GET_PED_RELATIONSHIP_GROUP_HASH(attacker) == GAMEPLAY::GET_HASH_KEY("RIOTERS")))//PED::GET_PED_RELATIONSHIP_GROUP_DEFAULT_HASH(ped1))
									//&& (PED::GET_PED_RELATIONSHIP_GROUP_HASH(attacker) != PED::GET_PED_RELATIONSHIP_GROUP_DEFAULT_HASH(attacker)))
										//PED::SET_PED_RELATIONSHIP_GROUP_HASH(ped1, PED::GET_PED_RELATIONSHIP_GROUP_HASH(attacker));
										PED::SET_PED_RELATIONSHIP_GROUP_HASH(ped1, GAMEPLAY::GET_HASH_KEY("RIOTERS"));
									fight(ped1, attacker);
									if (isPedIdle(attacker) || isPedWaitingForTurn(attacker))
										fight(attacker, ped1);
								}
								else if (findVictim(ped1) != NULL)
								{
									fight(ped1, victim);
									if (isPedIdle(victim) || isPedWaitingForTurn(victim))
										fight(victim, attacker);
								}
								else if (checkPlayer(ped1))
									simpleFight(ped1, player);
								else if (PED::IS_COP_PED_IN_AREA_3D(position.x, position.y, position.z, 100, 100, 100))
									if (!odds && !odds2)
										fight(ped1, findClosestIdleTarget(ped1));
									else
										fight(ped1, findClosestCop(ped1));
								else if (oldStyle == 1)
								{
									if (!PED::IS_PED_IN_MELEE_COMBAT(ped1) && !PED::IS_PED_IN_COMBAT(ped1, true))
										simpleFight(ped1, findRandomTarget(ped1));
								}
								else if ((guns && !PED::IS_PED_IN_COMBAT(ped1, true))
								|| (isPedIdle(ped1) && PED::IS_PED_IN_MELEE_COMBAT(ped1)))
								{
									if (odds)
										fight(ped1, findRandomTarget(ped1));
									else
										fight(ped1, findClosestIdleTarget(ped1));
									registerLastTarget(ped1);
								}
								else if (currentTarget != NULL && !isPedWaitingForTurn(ped1) && (isPedIdle(ped1) && isPedIdle(currentTarget)))
								{ //if they're both "fighting" but really just staring at eachother
									fight(ped1, findIdleOpponent(ped1));
									fight(currentTarget, findClosestIdleTarget(currentTarget));
									registerLastTarget(ped1);
								}
								else if (!PED::IS_PED_IN_MELEE_COMBAT(ped1) && !PED::IS_PED_IN_COMBAT(ped1, true))
								{
									if (odds && odds2)
										fight(ped1, findRandomTarget(ped1));
									else
										fight(ped1, findIdleOpponent(ped1));
									registerLastTarget(ped1);
								}
								else if ((isPedWaitingForTurn(ped1) || isPedIdle(ped1)) && !arePedsFighting(ped1, currentTarget))
								{
									if (currentTarget != NULL && (ped1 != findCurrentTargetOf(currentTarget)))
									{
										targetPed = findClosestIdleTarget(ped1);
										simpleFight(ped1, targetPed);
										if ((isPedIdle(targetPed)) || isPedWaitingForTurn(targetPed))
											simpleFight(targetPed, ped1);
									}
									else if (isPedIdle(ped1) || isPedWaitingForTurn(ped1))
									{
										targetPed = findIdleOpponent(ped1);
										fight(ped1, targetPed);
										if (isPedIdle(targetPed) || isPedWaitingForTurn(targetPed))
											fight(targetPed, ped1);
										registerLastTarget(ped1);
									}
								}
								else if (GAMEPLAY::GET_RANDOM_INT_IN_RANGE(1, (switchRate)) == 1)
								{
									fight(ped1, findRandomTarget(ped1));
									registerLastTarget(ped1);
								}
							} // end combat assignments----------------------------------------------S
							if (checkStage)
							{
								if (stunGun == 1)
									flameStun(ped1);

								if (remGuns == 1)
									removeWeapons(ped1);

								if (!isPedCop(ped1) && PED::IS_PED_GETTING_INTO_A_VEHICLE(ped1) || (!WEAPON::IS_PED_ARMED(ped1, 0xFF)
								&& !PED::IS_PED_IN_COMBAT(ped1, true)))
								{
									if ((guns == 1) || PED::IS_PED_GETTING_INTO_A_VEHICLE(ped1) || ((PED::IS_PED_MALE(ped1) && (GAMEPLAY::GET_RANDOM_INT_IN_RANGE(1, cfgMen) == 1))
									|| (!PED::IS_PED_MALE(ped1) && (GAMEPLAY::GET_RANDOM_INT_IN_RANGE(1, cfgFem) == 1))))
									{
										if (guns == 1)
										{
											gunhash = GAMEPLAY::GET_HASH_KEY(weapons2[GAMEPLAY::GET_RANDOM_INT_IN_RANGE(0, firearms)]);
											if ((WEAPON::IS_WEAPON_VALID(gunhash) && PED::IS_PED_HUMAN(ped1)))
											WEAPON::GIVE_DELAYED_WEAPON_TO_PED(ped1, gunhash, 300, 1);
										}
										else
										{
											weaponhash = GAMEPLAY::GET_HASH_KEY(weapons[GAMEPLAY::GET_RANDOM_INT_IN_RANGE(0, melee)]);
											if ((WEAPON::IS_WEAPON_VALID(weaponhash) && PED::IS_PED_HUMAN(ped1)))
											WEAPON::GIVE_DELAYED_WEAPON_TO_PED(ped1, weaponhash, 300, 1);
										}
										PED::SET_PED_CAN_SWITCH_WEAPON(ped1, false);
									}
								}
								if (peds.size() > 1)
								{
									//Drivers-------------------------------------------------
									Object driveTask;
									AI::OPEN_SEQUENCE_TASK(&driveTask);
									if (PED::IS_PED_IN_ANY_VEHICLE(ped1, true))
									{

										PED::SET_PED_FIRING_PATTERN(ped1, GAMEPLAY::GET_HASH_KEY("FIRING_PATTERN_BURST_FIRE_DRIVEBY"));
										if (PED::IS_PED_IN_COMBAT(ped1, true) || VEHICLE::IS_VEHICLE_STOPPED(veh) && ((pedsLeaveVeh == 1) || GAMEPLAY::GET_RANDOM_INT_IN_RANGE(1, pedsLeaveVeh) == 1))
										{
											targetPed = findCurrentTargetOf(ped1);
											if (!PED::IS_PED_IN_FLYING_VEHICLE(ped1))
											{
												targetPed = findCurrentTargetOf(ped1);
												clearTasks(ped1);
												AI::TASK_EVERYONE_LEAVE_VEHICLE(veh);
												AI::TASK_PAUSE(ped1, 1024);
												AI::TASK_STAND_STILL(ped1, 3000);
												//clearTasks(ped1);
												if (guns)
													AI::TASK_COMBAT_PED(ped1, targetPed, 0, 16);
												else
													AI::TASK_PUT_PED_DIRECTLY_INTO_MELEE(ped1, targetPed, 0, 0, 0, 0);
											}
											else if (pilotsNoLeaveVeh == 0)
											{
												//WEAPON::GIVE_DELAYED_WEAPON_TO_PED(ped1, 4222310262, 100, 1);
												//Object bailTask;
												//AI::OPEN_SEQUENCE_TASK(&bailTask);
												targetPed = findCurrentTargetOf(ped1);
												clearTasks(ped1);
												WEAPON::GIVE_DELAYED_WEAPON_TO_PED(ped1, GAMEPLAY::GET_HASH_KEY("GADGET_PARACHUTE"), 100, 1);
												AI::TASK_EVERYONE_LEAVE_VEHICLE(veh);
												AI::TASK_LEAVE_ANY_VEHICLE(ped1, 0, 0);
												wakePed(ped1);
												//AI::CLOSE_SEQUENCE_TASK(bailTask);
												//AI::TASK_PERFORM_SEQUENCE(ped1, bailTask);
												//PED::SET_PED_KEEP_TASK(ped1, 1);
												if (guns)
													AI::TASK_COMBAT_PED(ped1, targetPed, 0, 16);
												else
													AI::TASK_PUT_PED_DIRECTLY_INTO_MELEE(ped1, targetPed, 0, 0, 0, 0);
												//simpleFight(ped1, targetPed);
											}
										}
									}
									AI::CLOSE_SEQUENCE_TASK(driveTask);
									AI::TASK_PERFORM_SEQUENCE(ped1, driveTask);
									PED::SET_PED_KEEP_TASK(ped1, 1);
									PED::RESET_PED_IN_VEHICLE_CONTEXT(ped1);
									PED::RESET_PED_LAST_VEHICLE(ped1);
									if (!combatStage && checkPlayer(ped1))
										simpleFight(ped1, player);
								}
							}
						} //end if (canPedRiot)
						if ((pedsIgnoreAll == 1) || (GAMEPLAY::GET_RANDOM_INT_IN_RANGE(1, pedsIgnoreAll) == 1))
							peds.push_back(ped1);
					} //end of "numRioters" for-loop

				}  //end if (nearbyPed != null)
				if (combatStage)
					combatStage = false;
				if (checkStage)
					checkStage = false;
				//ready = !ready;
			}//end main if statement
		} //end if-active
		WAIT(0);
	} //end while loop
} //end main()

void ScriptMain()
{
	srand(GetTickCount());
	main();
}
